#!/bin/sh

# get-versions.sh

# exit codes
# 0 = succes

#version

VERSION="0.0.2"

SCRIPT=`readlink -f $0`
SCRIPTPATH=`dirname $SCRIPT`

# check options

if [ $# -eq 1 ]; then
  if [ $1 = "--version" ]; then
    echo -n $VERSION
    exit 0
  fi
fi

if [ $# -eq 1 ]; then
  FILE=$1
else
  FILE="x"
fi


# define FILE_BV
FILE_BV=/home/dctp/sms/smsfrontend/versions


# get_version_x = get version by executing a file with parameter

get_version_x() {
  if [ $# -eq 2 ]; then
    if [ -x $1 ]; then
      RESULT=`$1 $2`
      if [ "x"$RESULT = "x" ]; then
        RESULT=0.0.0
      fi
    else
      RESULT=0.0.0
    fi
  else
    RESULT=0.0.0
  fi
}


# get_version_g = get version by grepping a file

get_version_g() {
  if [ $# -eq 2 ]; then
    if [ -f $1 ]; then
      RESULT=`grep "^$2=" "$1" | sed 's/^[^=]*=//'`
      if [ "x"$RESULT = "x" ]; then
        RESULT=?
      fi
    else
      RESULT=?
    fi
  else
    RESULT=?
  fi
}


# compare versions

compare() {
  if [ "$1" != "$2" ]; then
    RESULT="*"
    RESULT2="*"
  else
    RESULT=" "
  fi
}


# xml_print_begin_package
# xml_print_end_package
# param1 = name
# param2 = version
# param3 = note

xml_print_begin_package() {
  if [ $# -eq 3 ]; then
    if [ "$3" != "hide" ]; then
      echo -e -n "\t<"
      echo -e -n "package "
      echo -e -n "name=\"$1\" "
      echo -e -n "vs=\"$2\" "
      echo -e -n "note=\"$3\" "
      echo -e ">"
    fi
  fi
}

xml_print_end_package() {
  if [ $# -eq 3 ]; then
    if [ "$3" != "hide" ]; then
      echo -e -n "\t<"
      echo -e -n "/package"
      echo -e ">"
    fi
  fi
}


# xml_print_begin_cat
# xml_print_end_cat
# param1 = name
# param2 = "hide" or " "

xml_print_begin_cat() {
  if [ $# -eq 2 ]; then
    if [ "$2" != "hide" ]; then
      echo -e -n "\t\t<"
      echo -e -n "cat "
      echo -e -n "name=\"$1\" "
      echo -e ">"
    fi
  fi
}

xml_print_end_cat() {
  if [ $# -eq 2 ]; then
    if [ "$2" != "hide" ]; then
      echo -e -n "\t\t<"
      echo -e -n "/cat"
      echo -e ">"
    fi
  fi
}


# xml_print_file
# param1 = name
# param2 = displayname
# param3 = version
# param4 = note

xml_print_file() {
  if [ $# -eq 4 ]; then
    if [ "$4" != "hide" ]; then
      echo -e -n "\t\t\t<"
      echo -e -n "file "
      echo -e -n "name=\"$1\" "
      echo -e -n "displayname=\"$2\" "
      echo -e -n "vs=\"$3\" "
      echo -e -n "note=\"$4\" "
      echo -e "/>"
    fi
  fi
}


get_version_x "$SCRIPT" --version
VS_GET_VERSIONS_SCRIPT=$RESULT
# get_version_g $FILE_BV "get versions script"
VS_TEMP=$RESULT
compare "$VS_GET_VERSIONS_SCRIPT" "$VS_TEMP"
NT_GET_VERSIONS_SCRIPT=$RESULT


# barco package (part 1)

# read package version
get_version_g $FILE_BV "package_version"
VS_BARCO_PACKAGE=$RESULT
NT_BARCO_VERSIONS_FILE=


# barco applications

get_version_x "/home/dctp/sms/smsfrontend/tp_commander" --version
VS_SMS_PROGRAM=$RESULT
get_version_g $FILE_BV "tp_sms_version"
VS_TEMP=$RESULT
compare "$VS_SMS_PROGRAM" "$VS_TEMP"
NT_SMS_PROGRAM=$RESULT


NT_BARCO_PACKAGE=$RESULT2

# output - begin

echo -e "<versioninfo> "
echo -e "\t<device name=\"DCTP\" id=\"barco.dctp\"/>"

# output - package1
xml_print_begin_package "DCTP package" "$VS_BARCO_PACKAGE" "$NT_BARCO_PACKAGE"

# output - Scripts
xml_print_begin_cat "Scripts" "$NT_EXTRA"

xml_print_file "get_versions" "get versions script" "$VS_GET_VERSIONS_SCRIPT" "$NT_GET_VERSIONS_SCRIPT"

xml_print_end_cat "Scripts" "$NT_EXTRA"


# output - Software
xml_print_begin_cat "Software" " "

xml_print_file "smsfrontend" "sms frontend program" "$VS_SMS_PROGRAM" "$NT_SMS_PROGRAM"

xml_print_end_cat "Software" " "


# output - package 1 end
xml_print_end_package "DCTP" "$VS_BARCO_PACKAGE" "$NT_BARCO_PACKAGE"

# output - end
echo -e "</versioninfo>"
