#!/bin/sh

NO_ERROR=0
LOW_ERROR=1
FATAL_ERROR=2

RET_ERROR=0

STARTLOGINFO="<update cat=\"log\" level=\"info\">"
STARTLOGERROR="<update cat=\"log\" level=\"error\">"
ENDLOGINFO="</update>"

echo $STARTLOGINFO"  installing sms frontend files"$ENDLOGINFO

IMAGE=`pwd`/image/smsfrontend.tar.gz
TARGETDIR=/home/dctp/sms
NEED_REBOOT=false

killall tp_commander
if [ -d $TARGETDIR/smsfrontend ]; then
 rm -Rf $TARGETDIR/smsfrontend
fi

cd $TARGETDIR
tar -xzf $IMAGE
RET_ERROR=$?
# chown -R root:root $TARGETDIR/smsfrontend/tp_commander
# chmod +x $TARGETDIR/smsfrontend/tp_commander

# restart Communicator: after kill, it will be restarted by watchdog
killall tp_target

if [ $RET_ERROR -ne 0 ];then
  echo $STARTLOGERROR"  failed to install new tp sms frontend files"$ENDLOGINFO
  RET_ERROR=2
else
  if $NEED_REBOOT; then
   # reboot needed so that Communicator detects
   echo "<update cat=\"control\" setting=\"request.reboot.when.done\"/>"
  fi
fi

exit $RET_ERROR